<script setup lang="ts">
import { computed, onMounted, type PropType, ref, watch } from "vue";
import type { ExtendedColors, SizeModifierType } from "@/types/PropTypes";

const model = defineModel({ required: true });

const props = defineProps({
  parameter: {
    type: Object,
    required: true,
    validator(value: Record<string, never>) {
      return "number" === value["type"] || "integer" === value["type"];
    },
  },
  required: Boolean,
  helpId: {
    type: String,
  },
  sizeModifier: {
    type: String as PropType<SizeModifierType>,
  },
  border: String as PropType<ExtendedColors>,
  id: String,
  customValidity: { type: String, required: false },
});

const numberInput = ref<HTMLInputElement | undefined>(undefined);

watch(
  () => props.customValidity,
  (newVal, oldVal) => {
    if (newVal != oldVal) {
      numberInput.value?.setCustomValidity(newVal ?? "");
    }
  },
);

const dynamicCssClasses = computed<string[]>(() => {
  const cssClasses = [];
  if (props.sizeModifier) {
    cssClasses.push(`form-control-${props.sizeModifier}`);
  }
  if (props.border) {
    cssClasses.push("border", `border-${props.border}`);
  }
  return cssClasses;
});

onMounted(() => {
  numberInput.value?.setCustomValidity(props.customValidity ?? "");
});
</script>

<template>
  <input
    :id="id"
    ref="numberInput"
    v-model="model"
    class="form-control flex-fill"
    :class="dynamicCssClasses"
    type="number"
    :max="props.parameter['maximum']"
    :min="props.parameter['minimum']"
    :step="props.parameter['type'] === 'integer' ? 1 : 0.0001"
    :required="props.required"
    :aria-describedby="props.helpId"
  />
</template>

<style scoped></style>
